<?php

class it_woocommerce_category_pricing_rules_admin
{

    public function __construct()
    {
        $this->post_save();
    }

    function post_save()
    {
        if (isset($_POST['action']) && $_POST['action'] == 'add') {
            $add_rule_cap_title = $_POST['add_rule_cap_title'];
//            if (!is_array($caps))
            $caps = array();
		
            $role = $this->createNewName($add_rule_cap_title);

            if (!is_array($role)) {
                return false;
            }
            $new_role = add_role($role['name'], $role['display'], $caps);
            if (is_object($new_role)) {
                return $role['name'];
            } else {
                return false;
            }
        } elseif (isset($_POST['action']) && isset($_POST['remove_rules']) && $_POST['action'] == 'delete' && is_array($_POST['remove_rules'])) {
            foreach ($_POST['remove_rules'] as $rule)
            {
                if (get_role($rule)) {
                    remove_role($rule);
                }
            }
        }
    }

    function ak_get_roles($translate = false)
    {
        global $wp_roles;
        if (!isset($wp_roles)) {
            $wp_roles = new WP_Roles();
        }

        $roles = $wp_roles->get_names();
        if ($translate) {
            foreach ($roles as $k => $r) {
                $roles[$k] = _x($r, 'User role');
            }
            asort($roles);
            return apply_filters('alkivia_roles_translate', $roles);
        } else {
            $roles = array_keys($roles);
            asort($roles);
            return $roles;
        }
    }

    private function createNewName($name)
    {
        // Allow max 40 characters, letters, digits and spaces
        $name = trim(substr($name, 0, 40));
        $pattern = '/^[a-zA-Z][a-zA-Z0-9 _]+$/';

        if (preg_match($pattern, $name)) {
            $roles = $this->ak_get_roles();

            $name = strtolower($name);
            $name = str_replace(' ', '_', $name);
            if (in_array($name, $roles)) {
                return false;    // Already a role or capability with this name.
            }

            $display = explode('_', $name);
            $display = array_map('ucfirst', $display);
            $display = implode(' ', $display);

            return compact('name', 'display');
        } else {
            return false;
        }
    }

    public function basic_meta_box()
    {
        global $wp_roles;
        ?>
        <div id="poststuff" class="woocommerce-category-wrap">
            <form method="post" action="">
                <table class="it-rule-table">
                    <tr>
                        <th>
                            Role Name
                        </th>
                        <td>
                            <input type="text" name="add_rule_cap_title"/>
                        </td>
                    </tr>
                </table>
                <input type="hidden" name="action" value="add"/>
                <p class="submit">
                    <input type="submit" class="button-primary" value="<?php _e('Add User Role') ?>"/>
                </p>
            </form>
            <form method="post" action="">
                <table class="it-rule-table">
                    <tr>
                        <th>
                            Select Role For Remove
                        </th>
                        <td>
                            <table>

                <?php
                $all_roles = $wp_roles->roles;
                foreach ($all_roles as $role_id => $role) {
                    $condition_index = 0;

                    ?>
                        <tr>
                            <td>
                            <input type="checkbox"
                                   id=""
                                   name="remove_rules[<?php echo $role_id; ?>]"
                                   value="<?php echo $role_id; ?>" <?php if($role_id=='administrator'){echo 'disabled';}?>/>
                            <strong><?php echo $role['name']; ?></strong>
                            </td>
                        </tr>
                    <?php
                }
                ?>
                            </table>
                        </td>
                    </tr>
                </table>
                <input type = "hidden" name = "action" value = "delete" />
                <p class="submit">
                    <input type="submit" class="button-primary" value="<?php _e('Delete User Role') ?>"/>
                </p>
            </form>


        </div>
        <?php
    }
}
